function MSE = mcfqr_pri_b_1 (x, d, lambda, tam, N, M)

L = M*N;
efq1 = ones (1, M);
dfq2 = ones (L, M);
f = zeros (L, 1);
Ef = zeros (M);
for i =1:M
    Ef(M-i+1, i) = 1;
end
Ef_0 = zeros (M);
for i =1:M
    Ef_0(M-i+1, i) = 1;
end
eq1 = 1;
dq2 = ones (L, 1);
sen_p = zeros (L, M);
cos_p = ones (L, M);
cos = ones (L, 1);
sen = zeros (L, 1);
gamma = 1;

for k = 1 : tam - 1
    %1 (Verificado)
    efq1(:) = x(k+1,:);
    for j = 1:N
        for i = 1:M
            for p = 1:M
                temp1 = efq1(p);
                temp2 = lambda^.5 * dfq2 (M * (N - j + 1) - i + 1, p);
                efq1(p) = temp1 * cos(M * (j - 1) + i) - temp2 * sen (M * (j - 1) + i);
                dfq2(M * (N - j + 1) - i + 1, p) = temp1 * sen(M * (j - 1) + i) + temp2 * cos (M * (j - 1) + i);
            end
         end
    end
    
    %2(Verificado)
    temp_efq1 = efq1;
    for i = 1:M
        temp1 = temp_efq1(i);
        temp2 = lambda^.5 * Ef(M - i + 1, i);
        temp3 = sqrt (temp1^2 + temp2^2);
        sen_pp (i) = temp1/temp3;
        cos_pp (i) = temp2/temp3;
        Ef (M - i + 1, i) = temp3;
        for s = i + 1:M
            temp1 = temp_efq1(s);
            temp2 = lambda^.5 * Ef (M - i + 1, s);
            temp_efq1(s) = temp1 * cos_pp(i) - temp2 * sen_pp(i);
            Ef (M - i + 1, s) = temp1 * sen_pp(i) + temp2 * cos_pp(i);
        end
    end
    
    %3 (Verificado)
    Ef_0 = Ef;
    temp_dfq2 = dfq2;
    for j = 1:N
        for i = 1:M
            for s = 1:M
                %calcular sen_p y cos_p (j, i)
                temp1 = temp_dfq2 (M * (j - 1) + i, s);
                temp2 = Ef_0 (M - s + 1, s);
                sen_p (M * (j - 1) + i, s) = temp1 / sqrt (temp1^2 + temp2^2);
                cos_p (M * (j - 1) + i, s) = temp2 / sqrt (temp1^2 + temp2^2);
                Ef_0 (M - s + 1, s) = sqrt (temp1^2 + temp2^2);
                for p = s + 1:M
                    temp1 = temp_dfq2 (M * (j - 1) + i, p);
                    temp2 = Ef_0 (M - s + 1, p);
                    temp_dfq2 (M * (j - 1) + i, p) = temp1 * cos_p(M * (j - 1) + i, s) - temp2 * sen_p(M * (j - 1) + i, s);
                    Ef_0 (M - s + 1, p) = temp1 * sen_p(M * (j - 1) + i, s) + temp2 * cos_p(M * (j - 1) + i, s);
                end
            end
        end
    end
    
    aux = inv(Ef_0)' * x(k+1,:)';
    tempf = f;
    f(M*(N-1)+1:L) = aux;
    for j = 1:N-1
        for i = 1:M
            for s = 1:M
                f(M*(N-j)-i+1) = (tempf(M*(N-j+1)-i+1) - aux(M-s+1) * sen_p(M*(N-j+1)-i+1,s)) / cos_p(M*(N-j+1)-i+1,s);
                tempf(M*(N-j+1)-i+1) = f(M*(N-j)-i+1);
                aux(M-s+1) = -f(M*(N-j)-i+1)*sen_p(M*(N-j+1)-i+1,s) + aux(M-s+1) * cos_p(M*(N-j+1)-i+1,s);
            end
        end
    end
    
    gamma = 1;
    for j = 1:N    
        for i = 1:M
            sen(M*(j-1)+i) = f(M*(N-j+1)-i+1)/gamma;
            cos(M*(j-1)+i) = sqrt (1 - sen(M*(j-1)+i)^2);
            gamma = gamma * cos (M*(j-1)+i);
        end
    end
        
    %6 (Verificado)
    eq1 = d(k+1);
    for j = 1:N
        for i = 1:M
            temp1 = eq1;
            temp2 = lambda^.5 * dq2(M * (N - j + 1) - i + 1);
            eq1 = temp1 * cos (M * (j - 1) + i) - temp2 * sen(M * (j - 1) + i);
            dq2(M * (N - j + 1) - i + 1) = temp1 * sen (M * (j - 1) + i) + temp2 * cos(M * (j - 1) + i);
        end
    end
    
    %7 (Verificado)
    e (k+1) = eq1 / (realmin + gamma);
end

MSE = e;